#define CONFIGURE_INIT
#include <bsp.h>
#include <sched.h>
#include "system.h"
#include <stdlib.h>
#include <stdio.h>
#include "stm32f4xxx.h"
#include "stm32f4-gpio.h"

/*uint32_t stm32f4_get32(volatile uint32_t* addr); 
void stm32f4_put32(volatile uint32_t* addr, uint32_t value); 

volatile uint32_t *reg;

uint32_t stm32f4_get32(volatile uint32_t* addr){
	return *addr;
}

void stm32f4_put32(volatile uint32_t* addr, uint32_t value){
	*addr = value;
}*/

uint16_t gpioinit( void ){
    volatile uint32_t ra;
    uint32_t rx;

    ra=stm32f4_get32(RCCBASE+0x30);
    ra|=1<<3; //enable port D
    stm32f4_put32(RCCBASE+0x30,ra);

    //d12 = d15 output
    ra=stm32f4_get32(GPIODBASE+0x00);
    ra&=0x00FFFFFF;
    ra|=0x55000000;
    stm32f4_put32(GPIODBASE+0x00,ra);
    //push pull
    ra=stm32f4_get32(GPIODBASE+0x04);
    ra&=0xFFFF0FFF;
    stm32f4_put32(GPIODBASE+0x04,ra);

    return(0);
}

void* task_A(void* arg) {
 int iteration=0;
 struct timespec delay;
 while(iteration<10)
    {
    stm32f4_put32(GPIODBASE+BSRR,0x0000F000);
    printf("Task_A (id=%x)\n",pthread_self());                       
    iteration++;               
    delay.tv_sec=1;
    delay.tv_nsec=0;
    nanosleep(&delay,NULL);
    }
  pthread_exit(NULL);
  return 0;
}

void* task_B(void* arg) {
 int iteration=0;
 struct timespec delay;
 while(iteration<10)
    {
    stm32f4_put32(GPIODBASE+BSRR,0xF0000000);
    printf("Task_B (id=%x)\n",pthread_self());                       
    iteration++;               

    delay.tv_sec=1;
    delay.tv_nsec=0;
    nanosleep(&delay,NULL);
    }
  pthread_exit(NULL);
  return 0;
}

void *POSIX_Init(
  void *argument
)
{
  uint16_t stat;
   
  pthread_attr_t attr;
  pthread_t id;
  struct sched_param param;
  int status;

  struct timespec delay;

  printf( "******************** DESCRIPTION *******************\n" );
  printf("Blink the LEDs -RTEMS Flasher for STM32F4 !!!\n");
  printf("Author: Rosario Cirincione\n");
  printf("Nickname: saroy.popovich\n");
  printf("Date: 2013/11/03\n");
  printf("Location: SKLab-Electronics, Bologna\n");
  printf( "*** END OF DESCRIPTION START OF THREADS SCHEDULE ***\n" );
  stat=gpioinit();

  /* create thread */
 pthread_attr_init(&attr);
 status=pthread_attr_setinheritsched(&attr,PTHREAD_EXPLICIT_SCHED);
 if (status!=0)
  returncode("pthread_attr_setinheritsched",status);
 status=pthread_attr_setschedpolicy(&attr,SCHED_FIFO);
 if (status!=0)
  returncode("pthread_attr_setschedpolicy",status);
 param.sched_priority=1;
 status=pthread_attr_setschedparam(&attr,&param);
 if (status!=0)
  returncode("pthread_attr_setschedparam",status);

 status=pthread_create(&id,&attr,task_A,NULL);
 if (status!=0)
  returncode("pthread_create1",status);

 delay.tv_sec=0;
 delay.tv_nsec=500000000;
 nanosleep(&delay,NULL); 

 status=pthread_create(&id,&attr,task_B,NULL);
 if (status!=0)
  returncode("pthread_create2",status);
 

 pthread_exit(NULL);
  exit(0);
}
